﻿Imports Microsoft.Office.Interop

Module Module1
    Sub Main()
        'Outlook-App erstellen
        Dim oApp As Outlook.Application = New Outlook.Application()

        'Mapi-NameSpace erstellen
        Dim oNS As Outlook.NameSpace = oApp.GetNamespace("mapi")
        oNS.Logon("", Reflection.Missing.Value, False, True)

        FindFolders(oNS.Folders)

        'Abmelden
        oNS.Logoff()
        oApp = Nothing
        oNS = Nothing

        Console.WriteLine("Drücken Sie eine beliebige Taste zum Beenden...")
        Console.ReadKey()
    End Sub

    ''' <summary>
    ''' Mithilfe von Rekursion alle Ordner (+Unterordner, usw.) finden, und 
    ''' jeden Ordner dann überprüfen
    ''' </summary>
    ''' <param name="currentFolder">
    '''  Übergeordneter Ordner, der nun durchsucht wird
    '''</param>
    Private Sub FindFolders(ByVal currentFolder As Outlook.Folders)
        For Each subFolder As Outlook.Folder In currentFolder
            FindMails(subFolder)
            FindFolders(subFolder.Folders)
        Next
    End Sub

    ''' <summary>
    ''' Überprüft einen Ordner auf ungelesene Mails, sollte es kein Mail-Ordner 
    ''' sein, wird das im Catch abgefangen
    ''' </summary>
    ''' <param name="folder">zu durchsuchender Ordner</param>
    Private Sub FindMails(ByVal folder As Outlook.MAPIFolder)
        Dim oItems As Outlook.Items
        Try
            oItems = folder.Items
            oItems = oItems.Restrict("[Unread] = true")

            If oItems.Count > 0 Then
                Console.WriteLine(oItems.Count & _
                    " ungelesene Email(s) in """ & folder.Name & """")
            Else
                Console.WriteLine("Keine neuen Nachrichten in """ & _
                    folder.Name & """")
            End If

        Catch ex As Exception
            If Not ex.Message = "Die Unread-Eigenschaft ist unbekannt." Then
                Throw ex
            Else
                ' Hier wird abgefangen falls man in keinen Mail-Ordner kommt, 
                '  sondern z.b. zu den Notizen
            End If
        Finally
            oItems = Nothing
        End Try
    End Sub
End Module
